/*
 *  Interactive disassembler (IDA).
 *  NEC V830
 */

#ifndef __INSTRS_HPP
#define __INSTRS_HPP

extern instruc_t Instructions[];

enum nameNum {
  V830_null = 0,    // Unknown Operation
/* load/store */
  V830_LD_B,	  // Load Byte
  V830_LD_H,	  // Load Halfword
  V830_LD_W,	  // Load Word
  V830_ST_B,	  // Store Byte
  V830_ST_H,	  // Store Halfword
  V830_ST_W,	  // Store Word
  V830_BILD,
  V830_BIST,
  V830_BDLD,
  V830_BDST,
  /* input/output */
  V830_IN_B,	  // Input Byte
  V830_IN_H,	  // Input Halfword
  V830_IN_W,	  // Input Word
  V830_OUT_B,	  // Output Byte
  V830_OUT_H,	  // Output Halfword
  V830_OUT_W,	  // Output Word
 /* arithmetic */
  V830_MOV,
  V830_MOVHI,
  V830_ADD,
  V830_ADDI,
  V830_MOVEA,
  V830_SUB,
  V830_MUL,
  V830_MULU,
  V830_DIV,
  V830_DIVU,
  V830_CMP,
  V830_SETF,
  V830_MIN3,
  V830_MAX3,
  V830_MUL3,
  V830_MAC3,
  V830_MULI,
  V830_MACI,
  V830_MULT3,
  V830_MACT3,
  V830_SATADD3,
  V830_SATSUB3,
/* logical operations */
  V830_OR,
  V830_ORI,
  V830_AND,
  V830_ANDI,
  V830_XOR,
  V830_XORI,
  V830_NOT,
  V830_SHL,
  V830_SHR,
  V830_SAR,
  V830_SHLD3,
  V830_SHRD3,
/* Branch instructions */
  V830_JMP,
  V830_JR,
  V830_JAL,
  V830_ABGT, V830_BGT,
  V830_ABGE, V830_BGE,
  V830_ABLT, V830_BLT,
  V830_ABLE, V830_BLE,
  V830_ABH,  V830_BH,
  V830_ABNL, V830_BNL,
  V830_ABL, V830_BL,
  V830_ABNH,  V830_BNH,
  V830_ABE, V830_BE,
  V830_ABNE, V830_BNE,
  V830_ABV,  V830_BV,
  V830_ABNV, V830_BNV,
  V830_ABN, V830_BN,
  V830_ABP,  V830_BP,
  V830_ABC, V830_BC,
  V830_ABNC, V830_BNC,
  V830_ABZ, V830_BZ,
  V830_ABNZ, V830_BNZ,
  V830_ABR,  V830_BR,
  V830_NOP,
/* Special Instructions */
  V830_LDSR,
  V830_STSR,
  V830_TRAP,
  V830_RETI,
  V830_CAXI,
  V830_HALT,
  V830_BRKRET,
  V830_EI,
  V830_DI,
  V830_STBY,
  
  V830_last
};

#endif
